/*
 * Debugger.java
 *
 * Created on 18 January 2007, 15:07
 */
package JCPC.ui;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import JCPC.core.*;
import JCPC.system.cpc.GateArray;
import JCPC.core.device.*;
import JCPC.core.device.memory.*;
import JCPC.util.diss.*;

/**
 *
 * @author Richard
 */
public class Debugger extends JFrame implements MouseListener, ActionListener {

    public static final Color navy = new Color(0, 0, 127);

    protected Computer computer;
    protected long startCycles = 0;

    protected JFileChooser fileDlg;

    public void INK(int pen, int col) {
//      if (pen == 16){
//          System.out.println(Util.hex(col));
//      }
        if (col == 0xFFFFFF) {
            col = 0x0FFFFFE;
        }
        Color color = new Color(col);
//        if (GateArray.cpc != null) {
//            vCC.setText(GateArray.cpc.getCRTC().getvCC() + "");
//            RA.setText(GateArray.cpc.getCRTC().getRA() + "");
//        }
        switch (pen) {
            case 0:
                panel1.setBackground(color);
                break;
            case 1:
                panel2.setBackground(color);
                break;
            case 2:
                panel3.setBackground(color);
                break;
            case 3:
                panel4.setBackground(color);
                break;
            case 4:
                panel5.setBackground(color);
                break;
            case 5:
                panel6.setBackground(color);
                break;
            case 6:
                panel7.setBackground(color);
                break;
            case 7:
                panel8.setBackground(color);
                break;
            case 8:
                panel9.setBackground(color);
                break;
            case 9:
                panel10.setBackground(color);
                break;
            case 10:
                panel11.setBackground(color);
                break;
            case 11:
                panel12.setBackground(color);
                break;
            case 12:
                panel13.setBackground(color);
                break;
            case 13:
                panel14.setBackground(color);
                break;
            case 14:
                panel15.setBackground(color);
                break;
            case 15:
                panel16.setBackground(color);
                break;
            case 16:
                panel17.setBackground(color);
                break;
        }
    }

    public void setReg(int reg, byte value) {
        switch (reg) {
            case 0:
                jTextField1.setText(Util.hex(value));
                break;
            case 1:
                jTextField2.setText(Util.hex(value));
                break;
            case 2:
                jTextField3.setText(Util.hex(value));
                break;
            case 3:
                jTextField4.setText(Util.hex(value));
                break;
            case 4:
                jTextField5.setText(Util.hex(value));
                break;
            case 5:
                jTextField6.setText(Util.hex(value));
                break;
            case 6:
                jTextField7.setText(Util.hex(value));
                break;
            case 7:
                jTextField8.setText(Util.hex(value));
                break;
            case 8:
                jTextField9.setText(Util.hex(value));
                break;
            case 9:
                jTextField10.setText(Util.hex(value));
                break;
            case 10:
                jTextField11.setText(Util.hex(value));
                break;
            case 11:
                jTextField12.setText(Util.hex(value));
                break;
            case 12:
                jTextField13.setText(Util.hex(value));
                break;
            case 13:
                jTextField14.setText(Util.hex(value));
                break;
            case 14:
                jTextField15.setText(Util.hex(value));
                break;
            case 15:
                jTextField16.setText(Util.hex(value));
                break;
            case 16:
                jTextField17.setText(Util.hex(value));
                break;
            case 17:
                jTextField18.setText(Util.hex(value));
                break;
        }
    }

    /**
     * Creates new form Debugger
     */
    public Debugger() {
        initComponents();
        eDisassembler.setFont(new Font("Monospaced", 0, 11));
        eMemory.setFont(new Font("Monospaced", 0, 11));
        jButton1.addActionListener(this);
        bRun.addActionListener(this);
        bStop.addActionListener(this);
        bStep.addActionListener(this);
        bStepOver.addActionListener(this);
        mSave.addActionListener(this);
        mGoto.addActionListener(this);
        jScrollPane1.getVerticalScrollBar().setUnitIncrement(getFontMetrics(eMemory.getFont()).getHeight());
    }

    public void setComputer(Computer value) {
        if (computer != null) {
            computer.removeActionListener(this);
        }
        computer = value;
        eDisassembler.setComputer(computer);
        eMemory.setComputer(computer);
        if (computer != null) {
            computer.addActionListener(this);
            eRegisters.setDevice(computer.getProcessor());
            updateDisplay();
        } else {
            eRegisters.setDevice(null);
        }
    }

    protected void updateDisplay() {
        eDisassembler.setPC(computer.getProcessor().getProgramCounter());
        lCycleCount.setText(Long.toString(computer.getProcessor().getCycles() - startCycles));
        eRegisters.setValues();
        repaint();
    }

    protected long getGotoAddress() {
        String address = JOptionPane.showInputDialog("Address: ", "#");
        if (address == null) {
            return -1;
        }
        address = address.trim();
        if (address.length() == 0) {
            return -1;
        }

        switch (address.charAt(0)) {
            case '#':
            case '&':
            case '$':
                return Long.parseLong(address.substring(1), 16);

            default:
                return Long.parseLong(address);
        }
    }

    public void actionPerformed(ActionEvent e) {
        computer.clearRunToAddress();
        if (e.getSource() == bRun) {
            computer.start();
        } else if (e.getSource() == bStop) {
            computer.stop();
        } else if (e.getSource() == bStep) {
            computer.step();
        } else if (e.getSource() == bStepOver) {
            computer.stepOver();
        } else if (e.getSource() == computer) {
            updateDisplay();
        } else if (e.getSource() == jButton1) {
            computer.getDisplay().DEBUG_SPRITES = true;
            jButton1.setEnabled(false);
        } else if (e.getSource() == mGoto) {
            long address = getGotoAddress();
            if (address != -1) {
                if (popupMenu.getInvoker() == eDisassembler) {
                    eDisassembler.setAddress((int) address);
                } else {
                    eMemory.setAddress((int) address);
                }
            }
        } else if (e.getSource() == mSave) {
            if (popupMenu.getInvoker() == eDisassembler) {
                saveDisassembly();
            } else {
                saveMemory();
            }
        }
        computer.setFrameSkip(0);
        computer.updateDisplay(false);
    }

    protected File showSaveDialog(String title) {
        if (fileDlg == null) {
            fileDlg = new JFileChooser();
        }
        fileDlg.setDialogTitle(title);
        return fileDlg.showSaveDialog(bRun) == JFileChooser.APPROVE_OPTION ? fileDlg.getSelectedFile() : null;
    }

    public void saveMemory() {
        saveMemory(eMemory.selStart, eMemory.selEnd);
    }

    public void saveMemory(int start, int end) {
        File file = showSaveDialog("Save Memory");
        if (file != null) {
            try {
                FileOutputStream io = new FileOutputStream(file);
                try {
                    Memory mem = computer.getMemory();
                    for (int addr = start; addr <= end; addr++) {
                        io.write(mem.readByte(addr));
                    }
                } finally {
                    io.close();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public void saveDisassembly() {
        saveDisassembly(eDisassembler.selStart, eDisassembler.selEnd);
    }

    public void saveDisassembly(int start, int end) {
        File file = showSaveDialog("Save Disassembly");
        if (file != null) {
            int[] addr = new int[]{start};
            try {
                FileOutputStream io = new FileOutputStream(file);
                try {
                    Disassembler diss = computer.getDisassembler();
                    Memory mem = computer.getMemory();
                    while (addr[0] <= end) {
                        String s = Util.hex((short) addr[0]) + ": ";
                        io.write((s + diss.disassemble(mem, addr) + "\r\n").getBytes());
                    }
                } finally {
                    io.close();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        popupMenu = new javax.swing.JPopupMenu();
        mGoto = new javax.swing.JMenuItem();
        mSave = new javax.swing.JMenuItem();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        panel1 = new javax.swing.JPanel();
        panel2 = new javax.swing.JPanel();
        panel3 = new javax.swing.JPanel();
        panel4 = new javax.swing.JPanel();
        panel5 = new javax.swing.JPanel();
        panel6 = new javax.swing.JPanel();
        panel7 = new javax.swing.JPanel();
        panel8 = new javax.swing.JPanel();
        panel9 = new javax.swing.JPanel();
        panel10 = new javax.swing.JPanel();
        panel11 = new javax.swing.JPanel();
        panel12 = new javax.swing.JPanel();
        panel13 = new javax.swing.JPanel();
        panel14 = new javax.swing.JPanel();
        panel15 = new javax.swing.JPanel();
        panel16 = new javax.swing.JPanel();
        panel17 = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        vCC = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        RA = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        lCycles = new javax.swing.JLabel();
        lCycleCount = new javax.swing.JLabel();
        eRegisters = new JCPC.ui.ERegisters();
        jSplitPane1 = new javax.swing.JSplitPane();
        eDisassembler = new JCPC.ui.EDisassembler();
        jScrollPane1 = new javax.swing.JScrollPane();
        eMemory = new JCPC.ui.EMemory();
        jPanel4 = new javax.swing.JPanel();
        bRun = new javax.swing.JButton();
        bStop = new javax.swing.JButton();
        bStep = new JCPC.ui.EButton();
        bStepOver = new JCPC.ui.EButton();
        jButton1 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextField6 = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextField10 = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextField11 = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextField12 = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextField13 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jTextField14 = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextField15 = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        jTextField16 = new javax.swing.JTextField();
        jLabel17 = new javax.swing.JLabel();
        jTextField17 = new javax.swing.JTextField();
        jLabel18 = new javax.swing.JLabel();
        jTextField18 = new javax.swing.JTextField();

        mGoto.setText("Goto...");
        popupMenu.add(mGoto);

        mSave.setText("Save...");
        popupMenu.add(mSave);

        setTitle("JavaGX4000 Debugger");

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        panel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel1.setMinimumSize(new java.awt.Dimension(18, 18));
        panel1.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel1);

        panel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel2.setMinimumSize(new java.awt.Dimension(18, 18));
        panel2.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel2);

        panel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel3.setMinimumSize(new java.awt.Dimension(18, 18));
        panel3.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel3);

        panel4.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel4.setMinimumSize(new java.awt.Dimension(18, 18));
        panel4.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel4);

        panel5.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel5.setMinimumSize(new java.awt.Dimension(18, 18));
        panel5.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel5);

        panel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel6.setMinimumSize(new java.awt.Dimension(18, 18));
        panel6.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel6);

        panel7.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel7.setMinimumSize(new java.awt.Dimension(18, 18));
        panel7.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel7);

        panel8.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel8.setMinimumSize(new java.awt.Dimension(18, 18));
        panel8.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel8);

        panel9.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel9.setMinimumSize(new java.awt.Dimension(18, 18));
        panel9.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel9);

        panel10.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel10.setMinimumSize(new java.awt.Dimension(18, 18));
        panel10.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel10);

        panel11.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel11.setMinimumSize(new java.awt.Dimension(18, 18));
        panel11.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel11);

        panel12.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel12.setMinimumSize(new java.awt.Dimension(18, 18));
        panel12.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel12);

        panel13.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel13.setMinimumSize(new java.awt.Dimension(18, 18));
        panel13.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel13);

        panel14.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel14.setMinimumSize(new java.awt.Dimension(18, 18));
        panel14.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel14);

        panel15.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel15.setMinimumSize(new java.awt.Dimension(18, 18));
        panel15.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel15);

        panel16.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel16.setMinimumSize(new java.awt.Dimension(18, 18));
        panel16.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel16);

        panel17.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panel17.setMinimumSize(new java.awt.Dimension(18, 18));
        panel17.setPreferredSize(new java.awt.Dimension(18, 18));
        jPanel2.add(panel17);

        jLabel19.setText("LineCounter:");
        jPanel2.add(jLabel19);

        vCC.setColumns(2);
        vCC.setText("00");
        jPanel2.add(vCC);

        jLabel20.setText("RasterCounter:");
        jPanel2.add(jLabel20);

        RA.setColumns(2);
        RA.setText("00");
        jPanel2.add(RA);

        jPanel1.add(jPanel2, java.awt.BorderLayout.CENTER);

        lCycles.setForeground(new java.awt.Color(0, 0, 127));
        lCycles.setText("Cycles:");
        jPanel3.add(lCycles);

        lCycleCount.setText("0");
        lCycleCount.addMouseListener(this);
        jPanel3.add(lCycleCount);

        jPanel1.add(jPanel3, java.awt.BorderLayout.EAST);

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);

        eRegisters.setFocusable(false);
        eRegisters.setLayout(null);
        getContentPane().add(eRegisters, java.awt.BorderLayout.LINE_END);

        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setContinuousLayout(true);

        eDisassembler.setComponentPopupMenu(popupMenu);
        eDisassembler.addMouseListener(this);
        jSplitPane1.setTopComponent(eDisassembler);

        eMemory.setComponentPopupMenu(popupMenu);
        jScrollPane1.setViewportView(eMemory);

        jSplitPane1.setRightComponent(jScrollPane1);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jPanel4.setPreferredSize(new java.awt.Dimension(100, 10));

        bRun.setText("Run");
        jPanel4.add(bRun);

        bStop.setText("Stop");
        jPanel4.add(bStop);

        bStep.setText("Step");
        jPanel4.add(bStep);

        bStepOver.setText("S.Over");
        jPanel4.add(bStepOver);

        jButton1.setText("Debug Sprites");
        jPanel4.add(jButton1);

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "CRTC", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        jPanel5.setMinimumSize(new java.awt.Dimension(10, 10));
        jPanel5.setPreferredSize(new java.awt.Dimension(90, 328));
        jPanel5.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 5, 0));

        jLabel1.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel1.setText("Reg. 00");
        jPanel5.add(jLabel1);

        jTextField1.setColumns(2);
        jTextField1.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField1.setText("0");
        jTextField1.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField1.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField1);

        jLabel2.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel2.setText("Reg. 01");
        jPanel5.add(jLabel2);

        jTextField2.setColumns(2);
        jTextField2.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField2.setText("0");
        jTextField2.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField2.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField2);

        jLabel3.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel3.setText("Reg. 02");
        jPanel5.add(jLabel3);

        jTextField3.setColumns(2);
        jTextField3.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField3.setText("0");
        jTextField3.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField3.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField3);

        jLabel4.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel4.setText("Reg. 03");
        jPanel5.add(jLabel4);

        jTextField4.setColumns(2);
        jTextField4.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField4.setText("0");
        jTextField4.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField4.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField4);

        jLabel5.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel5.setText("Reg. 04");
        jPanel5.add(jLabel5);

        jTextField5.setColumns(2);
        jTextField5.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField5.setText("0");
        jTextField5.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField5.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField5);

        jLabel6.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel6.setText("Reg. 05");
        jPanel5.add(jLabel6);

        jTextField6.setColumns(2);
        jTextField6.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField6.setText("0");
        jTextField6.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField6.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField6);

        jLabel7.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel7.setText("Reg. 06");
        jPanel5.add(jLabel7);

        jTextField7.setColumns(2);
        jTextField7.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField7.setText("0");
        jTextField7.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField7.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField7);

        jLabel8.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel8.setText("Reg. 07");
        jPanel5.add(jLabel8);

        jTextField8.setColumns(2);
        jTextField8.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField8.setText("0");
        jTextField8.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField8.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField8);

        jLabel9.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel9.setText("Reg. 08");
        jPanel5.add(jLabel9);

        jTextField9.setColumns(2);
        jTextField9.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField9.setText("0");
        jTextField9.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField9.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField9);

        jLabel10.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel10.setText("Reg. 09");
        jPanel5.add(jLabel10);

        jTextField10.setColumns(2);
        jTextField10.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField10.setText("0");
        jTextField10.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField10.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField10);

        jLabel11.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel11.setText("Reg. 10");
        jPanel5.add(jLabel11);

        jTextField11.setColumns(2);
        jTextField11.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField11.setText("0");
        jTextField11.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField11.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField11);

        jLabel12.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel12.setText("Reg. 11");
        jPanel5.add(jLabel12);

        jTextField12.setColumns(2);
        jTextField12.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField12.setText("0");
        jTextField12.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField12.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField12);

        jLabel13.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel13.setText("Reg. 12");
        jPanel5.add(jLabel13);

        jTextField13.setColumns(2);
        jTextField13.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField13.setText("0");
        jTextField13.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField13.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField13);

        jLabel14.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel14.setText("Reg. 13");
        jPanel5.add(jLabel14);

        jTextField14.setColumns(2);
        jTextField14.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField14.setText("0");
        jTextField14.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField14.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField14);

        jLabel15.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel15.setText("Reg. 14");
        jPanel5.add(jLabel15);

        jTextField15.setColumns(2);
        jTextField15.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField15.setText("0");
        jTextField15.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField15.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField15);

        jLabel16.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel16.setText("Reg. 15");
        jPanel5.add(jLabel16);

        jTextField16.setColumns(2);
        jTextField16.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField16.setText("0");
        jTextField16.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField16.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField16);

        jLabel17.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel17.setText("Reg. 16");
        jPanel5.add(jLabel17);

        jTextField17.setColumns(2);
        jTextField17.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField17.setText("0");
        jTextField17.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField17.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField17);

        jLabel18.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jLabel18.setText("Reg. 17");
        jLabel18.setRequestFocusEnabled(false);
        jPanel5.add(jLabel18);

        jTextField18.setColumns(2);
        jTextField18.setFont(new java.awt.Font("Monospaced", 0, 10)); // NOI18N
        jTextField18.setText("0");
        jTextField18.setMinimumSize(new java.awt.Dimension(18, 16));
        jTextField18.setPreferredSize(new java.awt.Dimension(18, 16));
        jPanel5.add(jTextField18);

        jPanel4.add(jPanel5);

        getContentPane().add(jPanel4, java.awt.BorderLayout.WEST);

        pack();
    }

    // Code for dispatching events from components to event handlers.

    public void mouseClicked(java.awt.event.MouseEvent evt) {
        if (evt.getSource() == lCycleCount) {
            Debugger.this.lCycleCountMouseClicked(evt);
        }
        else if (evt.getSource() == eDisassembler) {
            Debugger.this.eDisassemblerMouseClicked(evt);
        }
    }

    public void mouseEntered(java.awt.event.MouseEvent evt) {
    }

    public void mouseExited(java.awt.event.MouseEvent evt) {
    }

    public void mousePressed(java.awt.event.MouseEvent evt) {
    }

    public void mouseReleased(java.awt.event.MouseEvent evt) {
    }// </editor-fold>//GEN-END:initComponents

  private void eDisassemblerMouseClicked(java.awt.event.MouseEvent e) {//GEN-FIRST:event_eDisassemblerMouseClicked
      if (e.getClickCount() == 2) {
          int addr = eDisassembler.getAddress(e.getY());
          if (addr != -1) {
              computer.setRunToAddress(addr);
              computer.start();
          }
      }
  }//GEN-LAST:event_eDisassemblerMouseClicked

  private void lCycleCountMouseClicked(java.awt.event.MouseEvent e) {//GEN-FIRST:event_lCycleCountMouseClicked
      if (e.getClickCount() == 2) {
          startCycles = computer.getProcessor().getCycles();
          lCycleCount.setText("0");
      }
  }//GEN-LAST:event_lCycleCountMouseClicked

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JTextField RA;
    protected javax.swing.JButton bRun;
    protected JCPC.ui.EButton bStep;
    protected JCPC.ui.EButton bStepOver;
    protected javax.swing.JButton bStop;
    protected JCPC.ui.EDisassembler eDisassembler;
    protected JCPC.ui.EMemory eMemory;
    protected JCPC.ui.ERegisters eRegisters;
    protected javax.swing.JButton jButton1;
    protected javax.swing.JLabel jLabel1;
    protected javax.swing.JLabel jLabel10;
    protected javax.swing.JLabel jLabel11;
    protected javax.swing.JLabel jLabel12;
    protected javax.swing.JLabel jLabel13;
    protected javax.swing.JLabel jLabel14;
    protected javax.swing.JLabel jLabel15;
    protected javax.swing.JLabel jLabel16;
    protected javax.swing.JLabel jLabel17;
    protected javax.swing.JLabel jLabel18;
    protected javax.swing.JLabel jLabel19;
    protected javax.swing.JLabel jLabel2;
    protected javax.swing.JLabel jLabel20;
    protected javax.swing.JLabel jLabel3;
    protected javax.swing.JLabel jLabel4;
    protected javax.swing.JLabel jLabel5;
    protected javax.swing.JLabel jLabel6;
    protected javax.swing.JLabel jLabel7;
    protected javax.swing.JLabel jLabel8;
    protected javax.swing.JLabel jLabel9;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.JPanel jPanel2;
    protected javax.swing.JPanel jPanel3;
    protected javax.swing.JPanel jPanel4;
    protected javax.swing.JPanel jPanel5;
    protected javax.swing.JScrollPane jScrollPane1;
    protected javax.swing.JSplitPane jSplitPane1;
    protected static javax.swing.JTextField jTextField1;
    protected static javax.swing.JTextField jTextField10;
    protected static javax.swing.JTextField jTextField11;
    protected static javax.swing.JTextField jTextField12;
    protected static javax.swing.JTextField jTextField13;
    protected static javax.swing.JTextField jTextField14;
    protected static javax.swing.JTextField jTextField15;
    protected static javax.swing.JTextField jTextField16;
    protected static javax.swing.JTextField jTextField17;
    protected static javax.swing.JTextField jTextField18;
    protected static javax.swing.JTextField jTextField2;
    protected static javax.swing.JTextField jTextField3;
    protected static javax.swing.JTextField jTextField4;
    protected static javax.swing.JTextField jTextField5;
    protected static javax.swing.JTextField jTextField6;
    protected static javax.swing.JTextField jTextField7;
    protected static javax.swing.JTextField jTextField8;
    protected static javax.swing.JTextField jTextField9;
    protected javax.swing.JLabel lCycleCount;
    protected javax.swing.JLabel lCycles;
    protected javax.swing.JMenuItem mGoto;
    protected javax.swing.JMenuItem mSave;
    protected static javax.swing.JPanel panel1;
    protected static javax.swing.JPanel panel10;
    protected static javax.swing.JPanel panel11;
    protected static javax.swing.JPanel panel12;
    protected static javax.swing.JPanel panel13;
    protected static javax.swing.JPanel panel14;
    protected static javax.swing.JPanel panel15;
    protected static javax.swing.JPanel panel16;
    protected static javax.swing.JPanel panel17;
    protected static javax.swing.JPanel panel2;
    protected static javax.swing.JPanel panel3;
    protected static javax.swing.JPanel panel4;
    protected static javax.swing.JPanel panel5;
    protected static javax.swing.JPanel panel6;
    protected static javax.swing.JPanel panel7;
    protected static javax.swing.JPanel panel8;
    protected static javax.swing.JPanel panel9;
    protected javax.swing.JPopupMenu popupMenu;
    public javax.swing.JTextField vCC;
    // End of variables declaration//GEN-END:variables

}
