package JCPC.ui;

import JCPC.core.*;
import JCPC.core.device.*;
import JCPC.core.device.floppy.*;
import JCPC.core.device.sound.JavaSound;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import JCPC.core.device.crtc.Basic6845;
import JCPC.system.cpc.CPC;
import JCPC.system.cpc.GateArray;
import JCPC.system.cpc.Samples;
import com.nilo.plaf.nimrod.NimRODLookAndFeel;
import com.nilo.plaf.nimrod.NimRODTheme;
import java.awt.image.BufferedImage;
import java.util.List;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetAdapter;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DnDConstants;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetEvent;
import java.io.IOException;
import javax.swing.event.InternalFrameEvent;

/**
 * Title: GX4000 Description: Amstrad GX4000/CPC+ Emulator Copyright: Copyright
 * (c) 2013 Company: cpc-live.com
 *
 * @author Markus, Richard
 * @version 1.5
 */
public class GX4000 extends Applet implements ItemListener, ActionListener, KeyListener,
        FocusListener, Runnable, MouseListener, MouseMotionListener {

    GX4000Menu menu;
    EmuControl control;

    private ArrayList<DropTarget> dropTargetList;

    public void showDebugger() {
        try {
            System.out.println("showDebugger");
            if (debug == null) {
                debug = (Debugger) Util.secureConstructor(Debugger.class,
                        new Class[]{}, new Object[]{});
                debug.setBounds(0, 0, 820, 600);
                debug.setComputer(computer);
            }
            System.out.println("Showing Debugger");
            debug.setVisible(true);
            debug.toFront();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    public static Debugger debug = null;

    public static boolean hasSkin;

    public void actionPerformed(ActionEvent e) {
        try {
            if (e.getSource() == control.controller) {
                setupController();
            }
            if (GateArray.cpc != null) {
                if (e.getSource() == control.syscart && !GateArray.cpc.gx4000) {
                    loadPlus();
                    display.requestFocus();
                }
                if (e.getSource() == control.syscart && GateArray.cpc.gx4000) {
                    loadGX();
                    display.requestFocus();
                }
            }
            if (e.getSource() == control.reset) {
                GateArray.cpc.softReset();
                display.requestFocus();
            }
            if (e.getSource() == control.fullscreen) {
                this.toggleFullscreen();
                display.requestFocus();
            }
        } catch (Exception r) {
        }
        if (menu != null) {
            if (e.getSource() == menu.jMenuItem1) {
                load();
            }
            if (e.getSource() == menu.jMenuItem2) {
                computer.openCPR();
            }
            if (e.getSource() == menu.jMenuItem3) {
                controller.setVisible(true);
            }
            if (e.getSource() == menu.jMenuItem5) {
                GateArray.cpc.checkCSD();
            }
            if (e.getSource() == menu.jMenuItem7) {
                GateArray.cpc.softReset();
            }
            if (e.getSource() == menu.jMenuItem8) {
                showDebugger();
            }
        }
    }
    boolean gifrec = false;

    public void itemStateChanged(ItemEvent e) {
        try {
            if (e.getSource() == control.filter) {
                display.scanlines = control.filter.isSelected();
                display.requestFocus();
            }
            if (e.getSource() == control.lightgun) {
                controller.trojan.setSelected(control.lightgun.isSelected());
                this.setLightgun(controller.trojan.isSelected());
            }
        } catch (Exception r) {
        }
        if (e.getSource() == control.fullsize) {
            if (menu != null) {
                menu.jCheckBoxMenuItem2.setSelected(control.fullsize.isSelected());
                if (menu.jCheckBoxMenuItem2.isSelected()) {
                    menu.jCheckBoxMenuItem3.setSelected(false);
                }
            }
            this.setFullSize(control.fullsize.isSelected());
            System.out.println("Changing display to " + (large ? "large size" : "small size"));
            try {
                Thread.sleep(100);
            } catch (Exception er) {
            }
            display.setPreferredSize(display.getPreferredSize());
            display.setSize(display.getPreferredSize());
            try {
                Thread.sleep(100);
            } catch (Exception er) {
            }
            if (frame != null) {
                frame.pack();
                Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
                frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
            }
            if (emu != null) {
                emu.pack();
            }
        }
        if (menu != null) {
            hasSkin = menu.jCheckBoxMenuItem3.getState();
//            System.out.println(hasSkin);
            if (menu.jCheckBoxMenuItem1 == e.getSource()) {
                display.DEBUG_FPS = menu.jCheckBoxMenuItem1.getState();
            }
            if (menu.jCheckBoxMenuItem7 == e.getSource()) {
                display.DEBUG_MIPS = menu.jCheckBoxMenuItem7.getState();
            }
            if (menu.jCheckBoxMenuItem4 == e.getSource()) {
                if (menu.jCheckBoxMenuItem4.isSelected()) {
                    if (!gifrec) {
                        display.startRec();
                        gifrec = true;
                    }
                } else if (gifrec) {
                    display.stopRec();
                    gifrec = false;
                }
            }
            if (menu.jCheckBoxMenuItem2 == e.getSource()) {
                control.fullsize.setSelected(menu.jCheckBoxMenuItem2.isSelected());
                this.setFullSize(menu.jCheckBoxMenuItem2.isSelected());
                if (menu.jCheckBoxMenuItem2.isSelected()) {
                    menu.jCheckBoxMenuItem3.setSelected(false);
                }
                System.out.println("Changing display to " + (large ? "large size" : "small size"));
                try {
                    Thread.sleep(100);
                } catch (Exception er) {
                }
                display.setPreferredSize(display.getPreferredSize());
                display.setSize(display.getPreferredSize());
                try {
                    Thread.sleep(100);
                } catch (Exception er) {
                }
                if (frame != null) {
                    frame.pack();
                    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
                    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
                }
                if (emu != null) {
                    emu.pack();
                }
            }
            if (menu.jCheckBoxMenuItem3 == e.getSource()) {
                keepmonitor = menu.jCheckBoxMenuItem3.getState();
                if (keepmonitor) {
                    menu.jCheckBoxMenuItem2.setSelected(false);
                }
                this.setFullSize(menu.jCheckBoxMenuItem2.getState());
                System.out.println("Changing display to " + (large ? "large size" : "small size"));
                try {
                    Thread.sleep(100);
                } catch (Exception er) {
                }
                display.setPreferredSize(display.getPreferredSize());
                display.setSize(display.getPreferredSize());
                try {
                    Thread.sleep(100);
                } catch (Exception er) {
                }
                if (frame != null) {
                    frame.pack();
                    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
                    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
                }
                if (emu != null) {
                    emu.pack();
                }
            }
        }
        if (e.getSource() == controller.trojan) {
            control.lightgun.setSelected(controller.trojan.isSelected());
            this.setLightgun(controller.trojan.isSelected());
        }
        if (e.getSource() == controller.cart) {
            GateArray.cpc.loadCart(controller.cart.getSelectedIndex());
        }
    }
//        g.setColor(Color.gray);
//        g.fillRect(720, 706, 60, 20);
    boolean menupossible = false;
    boolean penonscreen = false;

    public void mouseMoved(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();
        if (y < 50 && display.showdisks) {
            display.showtime = 50;
        }
        display.updateLightpen(x, y);
        if (lightpen) {
            if (display.fullscreen) {
                double xx = (double) (768) / (double) display.getWidth();
                double yy = (double) (544) / (double) display.getHeight();
                x = (int) ((double) x * xx);
                y = (int) ((double) y * yy);
            }
            GateArray.cpc.getCRTC().setLightpen(x, y, display.large, display.fullscreen, penonscreen);
        }
        if (large) {
            if (display.menumode && e.getX() > basex && e.getX() < basexmax && e.getY() > 50 && e.getY() < 530) {
                display.setCursor(new Cursor(Cursor.HAND_CURSOR));
            } else if (display.menumode && e.getX() > basex + 300 && e.getX() < basexmax + 300 && e.getY() > 50 && e.getY() < 400) {
                display.setCursor(new Cursor(Cursor.HAND_CURSOR));
            } else {
                menupossible = false;
                if (!lightpen) {
                    display.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                } else {
                    display.setCursor(penonscreen ? pen : gun);
                }
            }
        } else if ((e.getX() > 360 && e.getX() < 390 && e.getY() > 353 && e.getY() < 363)) {
            display.setCursor(new Cursor(Cursor.HAND_CURSOR));
            menupossible = true;
        } else if (display.menumode && e.getX() > 100 + display.xdist && e.getX() < 220 + display.xdist && e.getY() > 50 + display.ydist && e.getY() < 290 + display.ydist) {
            display.setCursor(new Cursor(Cursor.HAND_CURSOR));
        } else if (display.menumode && e.getX() > 250 + display.xdist && e.getX() < 370 + display.xdist && e.getY() > 50 + display.ydist && e.getY() < 214 + display.ydist) {
            display.setCursor(new Cursor(Cursor.HAND_CURSOR));
        } else {
            menupossible = false;
            if (!lightpen) {
                display.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            } else {
                display.setCursor(penonscreen ? pen : gun);
            }
        }
    }

    public void mouseDragged(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();
        display.updateLightpen(x, y);
        if (lightpen) {
            if (display.fullscreen) {
                double xx = (double) (768) / (double) display.getWidth();
                double yy = (double) (544) / (double) display.getHeight();
                x = (int) ((double) x * xx);
                y = (int) ((double) y * yy);
            }
            GateArray.cpc.getCRTC().setLightpen(x, y, display.large, display.fullscreen, true);
        }
    }
    protected static boolean developer = false;
    protected boolean URL = false;
    String CRTC = "3";
    boolean alt = false;
    int multiload = 0;
    String cartridge = "none";
    String load = "none";
    String loadb = "none";
    String sna = "none";
    protected Computer computer = null;
    Locale loc;
    String localkeys = "";
    public static boolean isStandalone = false;
    public Display display = new Display();
    protected boolean started = false;
    protected boolean large = false;

    public String getParameter(String key, String def) {
        try {
            return isStandalone ? System.getProperty(key, def) : (getParameter(key) != null ? getParameter(key) : def);
        } catch (Exception e) {
            return def;
        }
    }

    public GX4000() {
        enableEvents(AWTEvent.KEY_EVENT_MASK);
    }

    public void init() {
        localkeys = getLocale().toString().toUpperCase();
        display.requestFocus();
        if (isStandalone) {
            dropTargetList = new ArrayList<DropTarget>();
            DropListener myListener = new DropListener();
            registerDropListener(dropTargetList, display, myListener);
        }
    }

    public void stopMotor() {
        computer.stop();
    }

    public void startMotor() {
        computer.start();
    }

    JInternalFrame emu;

    public Computer getComputer() {
        return computer;
    }

    public JInternalFrame getEmu(final GX4000 emul) {
        if (emu == null) {
            emu = new JInternalFrame("JavaGX4000 - Amstrad CPC+ Emulator - Desktop") {

                @Override
                public void doDefaultCloseAction() {
                    System.out.println("Window closing!");
                    computer.reset();
                    computer.stop();
                    super.doDefaultCloseAction();
                }

            };
            emu.setDefaultCloseOperation(JInternalFrame.HIDE_ON_CLOSE);
            initMenu();
            emu.setJMenuBar(getMenu());
            emu.setLayout(new BorderLayout());
            emu.add(this, BorderLayout.CENTER);
            menu.jMenuItem4.setVisible(false);
            emu.pack();
            emu.setResizable(false);
            emu.setIconifiable(true);
            emu.setClosable(true);
        }
        return emu;
    }

    public JMenuBar getMenu() {
        menu.Menu.setFocusable(false);
        return menu.Menu;
    }

    public void init(String locale) {
        localkeys = locale;
        display.requestFocus();
        dropTargetList = new ArrayList<DropTarget>();
        DropListener myListener = new DropListener();
        registerDropListener(dropTargetList, display, myListener);
    }

    static boolean toDriveB;

    private class DropListener extends DropTargetAdapter {

        public void dragExit(DropTargetEvent dtde) {
            display.showdrives = 0;
        }

        public void dragOver(DropTargetDragEvent dtde) {

            int x = dtde.getLocation().x;
            int y = dtde.getLocation().y;
            if (x > 370 / (display.large ? 1 : 2)) {
                toDriveB = true;
            } else {
                toDriveB = false;
            }
            try {
                Transferable t = dtde.getTransferable();
                if (t.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {
                    Object userObject = t.getTransferData(DataFlavor.javaFileListFlavor);
                    if (userObject instanceof List) {
                        String fileName = ((List) userObject).get(0).toString();
                        if (fileName.toLowerCase().endsWith(".dsk")) {
                            display.showdrives = 20;
                        } else {
                            display.showdrives = 0;
                        }
                    } else {
                    }
                }
            } catch (Exception ex) {
                System.out.println("[MainForm::DropListener]" + ex);
            }

        }

        public void drop(DropTargetDropEvent dtde) {
            try {
                Transferable t = dtde.getTransferable();
                if (t.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {
                    dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
                    Object userObject = t.getTransferData(DataFlavor.javaFileListFlavor);
                    if (userObject instanceof java.util.List) {
                        String filename = ((java.util.List) userObject).get(0).toString();
                        if (filename.toLowerCase().endsWith(".dsk")) {
                            int d = computer.getCurrentDrive();
                            computer.setCurrentDrive(toDriveB ? 1 : 0);
                            loadFile(Computer.TYPE_SNAPSHOT, filename, false);
                            computer.setCurrentDrive(d);
                        } else {
                            loadFile(Computer.TYPE_SNAPSHOT, filename, false);
                        }

                    }
                    dtde.dropComplete(true);
                }
            } catch (UnsupportedFlavorException ex) {
//                System.out.println("[MainForm::DropListener]" + ex);
            } catch (IOException ex) {
//                System.out.println("[MainForm::DropListener]" + ex);
            }
        }
    }

    private static void registerDropListener(ArrayList<DropTarget> list, Container basePanel, DropListener myListener) {
        list.add(new DropTarget(basePanel, myListener));

        Component[] components = basePanel.getComponents();
        for (int i = 0; i < components.length; i++) {
            Component component = components[i];
            if (component instanceof Container) {
                registerDropListener(list, (Container) component, myListener);
            } else {
                list.add(new DropTarget(component, myListener));
            }
        }
    }

    public void init(Locale loc) {
        localkeys = loc.toString().toUpperCase();
        display.requestFocus();
    }
    String disk1 = "";
    String disk2 = "";

    JPanel show;

    public void startEngine(final GX4000 applet) {
        try {
            show = new JPanel();
            show.setBackground(new Color(0x27, 0x27, 0x27));
            show.setLayout(new BorderLayout());
            control = new EmuControl();
            controller = new Controller();
            fram = 0;
            disk2 = "";
            setLayout(new BorderLayout());
            CPC.cartindex = Integer.parseInt(getParameter("GAME", "25"));
            if (CPC.cartindex > 25 || CPC.cartindex < 0) {
                CPC.cartindex = 2;
            }
            large = Util.getBoolean(getParameter("LARGE", "true"));
            Display.scanlines = Util.getBoolean(getParameter("FILTER", "false"));
            Display.drawmonitor = Util.getBoolean(getParameter("GUI", "false"));
            keepmonitor = Display.drawmonitor;

            controller.trojan.addItemListener(this);
            controller.cart.setModel(new javax.swing.DefaultComboBoxModel(Display.carts));
            controller.cart.setSelectedIndex(CPC.cartindex);
            controller.cart.addItemListener(this);
            String url = getParameter("URL", "false");
            url = url.toUpperCase();
            if (url.equals("TRUE")) {
                URL = true;
            }
            String csd = getParameter("CSD", "false");
            csd = csd.toUpperCase();
            CPC.CSD = false;
            if (csd.equals("TRUE")) {
                CPC.CSD = true;
            }
            String type = getParameter("AUTOTYPE", null);
            String boot = getParameter("BOOT", null);
            CRTC = "3";
            CRTC = getParameter("CRTC", CRTC);
//            System.out.println("CRTC choosen : " + CRTC);
            if (CRTC.startsWith(("1"))) {
                CRTC = "1";
            }
            if (CRTC.startsWith(("3"))) {
                CRTC = "3";
            }
            if (CRTC.startsWith(("0"))) {
                CRTC = "0";
            }
            Basic6845.CRTC = Integer.parseInt(CRTC);
            cartridge = getParameter("CPR", "internal");
            if (CPC.CSD) {
                cartridge = "none";
            }
            if (cartridge.equals("internal")) {
                cartridge = "none";
                CPC.internal = true;
            }
            setComputer("CPCPLUS", true);
            load = getParameter("SNA", "none");
            sna = load;
            load = getParameter("DISK", load);
            if (load.startsWith("$")) {
                load = "none";
            }
            loadb = getParameter("DISKB", loadb);
            if (loadb.startsWith("$")) {
                loadb = "none";
            }
            disk2 = getParameter("DISK2", "");
            if (disk2.startsWith("$")) {
                disk2 = "";
            }
            Display.showdisks = false;
            if (disk2.length() > 1) {
                disk1 = load;
                Display.showdisks = true;
                Display.showtime = 150;
            }
            display.large = large;
            if (large) {
                display.setSize(768, display.highlines);
                display.divider = 2;
            } else {
                display.setSize(384, display.lowlines);
            }
            show.add(display, BorderLayout.CENTER);
//            display.setDoubleBuffered(true);
            display.setBackground(Color.black);
            display.addKeyListener(this);
            display.addMouseListener(this);
            display.addMouseMotionListener(this);
            display.addFocusListener(this);
            started = true;
            if (type != null) {
                computer.prepareAutotype(type);
            }
            if (boot != null) {
                if (boot.contains("/")) {
                    boot = boot.replace("/", "\"");
                    computer.prepareAutotype(boot);
                } else if (boot.equals("tape")) {
                    computer.prepareAutotype("|TAPE:RUN\"!\"");
                } else if (boot.startsWith("|")) {
                    computer.prepareAutotype(boot);
                } else {
                    computer.prepareAutotype("RUN\"" + boot + "\"");
                }
            }
            this.setLightgun(Util.getBoolean(getParameter("LIGHTGUN", "false")));
        } catch (Exception e) {
            e.printStackTrace();
        }

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                if (!cartridge.equals("none")) {
                    loadFile(Computer.TYPE_DISC_IMAGE, cartridge, true);
                }
                if (!load.equals("none") && sna.equals("none")) {
                    loadFile(Computer.TYPE_DISC_IMAGE, load, true);
                }
                if (load.equals("none") && !sna.equals("none")) {
                    loadit = 1;
                }
                if (!load.equals("none") && !sna.equals("none")) {
                    multiload = 1;
                }
                if (!loadb.equals("none")) {
                    computer.setCurrentDrive(1);
                    loadFile(Computer.TYPE_DISC_IMAGE, loadb, true);
                }
                computer.setCurrentDrive(0);
                if (frame != null) {
                    frame.pack();
                    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
                    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
                }
                if (emu != null) {
                    emu.pack();
                }
                fireUpdate.start();
                display.DEBUG_SPRITES = Util.getBoolean(getParameter("SPRITES", display.DEBUG_SPRITES ? "true" : "false"));
                display.DEBUG_SCREEN = Util.getBoolean(getParameter("SCREEN", display.DEBUG_SCREEN ? "true" : "false"));

                control.fullsize.setSelected(large);

                control.fullsize.addItemListener(applet);
                control.lightgun.addItemListener(applet);
                control.controller.addActionListener(applet);
                control.fullscreen.addActionListener(applet);
                control.syscart.addActionListener(applet);
//        control.syscart.setVisible(false);
                control.reset.addActionListener(applet);
                control.filter.addItemListener(applet);

                if (!asApplet && frame != null) {
                    initMenu();
                    frame.setJMenuBar(getMenu());
                }
                add(control, BorderLayout.NORTH);
                add(show, BorderLayout.CENTER);
                display.requestFocus();
            }
        });
    }

    protected int loadit = 0;

    public void start() {
        if (asApplet) {
            setStyle();
        }
        CPC.gx4000 = isStandalone;
        startEngine(this);
        display.requestFocus();
    }

    public void startEmbedded() {
        CPC.gx4000 = true;
        startEngine(this);
        display.requestFocus();
    }

    public boolean isStarted() {
        return started;
    }

    public void waitStart() {
        try {
            while (!started) {
                Thread.sleep(10);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void run() {
    }

    public void stop() {
        GateArray.cpc.reset();
        GateArray.cpc.getPSG().resetRegisters();
        computer.stop();
    }
    ActionListener update = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
            update();
        }
    };
    javax.swing.Timer fireUpdate = new javax.swing.Timer(50, update);
    int fram = 0;

    public void update() {
        if (fram < 1) {
            fram++;
            computer.reset();
            computer.reSync();
            if (frame != null) {
                frame.pack();
            }
        }
        if (loadit > 0) {
            loadit++;
            if (loadit > 5) {
                loadit = 0;
                loadFile(Computer.TYPE_SNAPSHOT, sna, true);
            }
        }
        if (multiload >= 1) {
            multiload++;
            if (multiload == 6) {
                loadFile(Computer.TYPE_SNAPSHOT, sna, true);
            }
            if (multiload == 8) {
                loadFile(Computer.TYPE_SNAPSHOT, load, true);
                multiload = 0;
            }
        }
    }

    public void keyTyped(KeyEvent e) {
    }
    private KeyTranslator translator = new KeyTranslator();

    public void setupController() {
        controller.setVisible(true);
    }
    JFrame fullframe;

    public void repaint() {
    }

    public void loadPlus() {
        GateArray.cpc.loadSystem();
    }

    public void loadGX() {
        GateArray.cpc.loadGX();
    }
    BufferedImage testim = new BufferedImage(768, 544, BufferedImage.TYPE_INT_RGB);

    public void toggleFullscreen() {
        alt = false;
        if (fullframe == null) {
            fullframe = new JFrame();
            fullframe.setUndecorated(true);
            fullframe.setLayout(new BorderLayout());
            GraphicsConfiguration conf = this.getGraphicsConfiguration();
            int monitors = conf.getDevice().getConfigurations().length;
            int device = 0;
            int h = conf.getDevice().getConfigurations()[device].getBounds().height;
            int w = conf.getDevice().getConfigurations()[device].getBounds().width;
            Dimension d = new Dimension(w, h);
            fullframe.setPreferredSize(d);
            fullframe.setSize(d);
            Image testit = testim.getScaledInstance(d.width, -1, Image.SCALE_FAST);
            display.left = new JPanel();
            display.right = new JPanel();
            display.left.setBackground(Color.black);
            display.right.setBackground(Color.black);
            Dimension dd = new Dimension(0, (d.height - testit.getHeight(null)) >> 1);
            display.left.setPreferredSize(dd);
            display.right.setPreferredSize(dd);
            if (testit.getHeight(null) > this.getHeight()) {
                testit = testim.getScaledInstance(-1, d.height, Image.SCALE_FAST);
                dd = new Dimension((d.width - testit.getWidth(null)) >> 1, Toolkit.getDefaultToolkit().getScreenSize().height);
                display.left.setPreferredSize(dd);
                display.right.setPreferredSize(dd);
                display.leftside = new BufferedImage(20, 280, BufferedImage.TYPE_INT_RGB);
                display.rightside = new BufferedImage(20, 280, BufferedImage.TYPE_INT_RGB);
                display.leftpixels = new int[20 * 280];
                display.rightpixels = new int[20 * 280];
                fullframe.add(display.left, BorderLayout.WEST);
                fullframe.add(display.right, BorderLayout.EAST);
                display.drawborder = true;
            } else {
                display.drawborder = false;
                fullframe.add(display.left, BorderLayout.NORTH);
                fullframe.add(display.right, BorderLayout.SOUTH);
            }
        }
        display.fullscreen = !display.fullscreen;
        if (display.fullscreen) {
            if (frame != null) {
                frame.setVisible(false);
            }
            this.setVisible(false);
            show.remove(display);
            fullframe.add(display, BorderLayout.CENTER);
            fullframe.setVisible(true);
        } else {
            fullframe.remove(display);
            show.add(display, BorderLayout.CENTER);
            show.repaint();
            fullframe.setVisible(false);
            this.setVisible(true);
            if (frame != null) {
                frame.setVisible(true);
                frame.pack();
            }
        }
        display.requestFocus();
    }
    Controller controller;

    public void toggleFilter() {
        display.scanlines = !display.scanlines;
    }

    boolean ctrl;

    public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_F12 && alt) {
            this.showDebugger();
            return;
        }
        if (e.getKeyCode() == KeyEvent.VK_SCROLL_LOCK) {
            this.setLightgun(!lightpen);
            controller.trojan.setSelected(lightpen);
        }
        if (e.getKeyCode() == KeyEvent.VK_ALT) {
            alt = true;
        }
        if (e.getKeyCode() == KeyEvent.VK_CONTROL) {
            ctrl = true;
        }
        if (alt && e.getKeyCode() == KeyEvent.VK_ENTER) {
            if (!display.menumode) {
                toggleFullscreen();
            }
        }
        if (e.getKeyCode() == KeyEvent.VK_F10) {
            e.consume();
            return;
        }
        for (int i = 0; i < 6; i++) {
            if (e.getKeyCode() == controller.keyevents[i]) {
                switch (i) {
                    case 0:
                        e.setKeyCode(KeyEvent.VK_NUMPAD5);
                        break;
                    case 1:
                        e.setKeyCode(KeyEvent.VK_NUMPAD0);
                        break;
                    case 2:
                        e.setKeyCode(KeyEvent.VK_NUMPAD8);
                        break;
                    case 3:
                        e.setKeyCode(KeyEvent.VK_NUMPAD2);
                        break;
                    case 4:
                        e.setKeyCode(KeyEvent.VK_NUMPAD4);
                        break;
                    case 5:
                        e.setKeyCode(KeyEvent.VK_NUMPAD6);
                        break;
                }
            }
        }
//        if (e.getKeyCode() == KeyEvent.VK_F3) {
//            return;
//        }
//        if (e.getKeyCode() == KeyEvent.VK_F2) {
//            return;
//        }
//        if (e.getKeyCode() == KeyEvent.VK_F1) {
//            return;
//        }
//        if (e.getKeyCode() == KeyEvent.VK_F7) {
//            return;
//        }
        e = translator.translate(e, localkeys);
        if (e.getKeyCode() == KeyEvent.VK_F12) {
            if (ctrl) {
                resetComputer();
            } else {
                GateArray.cpc.softReset();
            }
        }
        computer.processKeyEvent(e);
        e.consume();
    }

    public void keyReleased(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_SPACE && GateArray.cpc.gx4000) {
//            if (keepmonitor || large) {
            display.menumode = !display.menumode;
//            }
        }
        if (e.getKeyCode() == KeyEvent.VK_ALT) {
            alt = false;
        }
        if (e.getKeyCode() == KeyEvent.VK_CONTROL) {
            ctrl = false;
        }
        if (e.getKeyCode() == KeyEvent.VK_F10) {
            controller.setVisible(true);
            e.consume();
            return;
        }
        for (int i = 0; i < 6; i++) {
            if (e.getKeyCode() == controller.keyevents[i]) {
                switch (i) {
                    case 0:
                        e.setKeyCode(KeyEvent.VK_NUMPAD5);
                        break;
                    case 1:
                        e.setKeyCode(KeyEvent.VK_NUMPAD0);
                        break;
                    case 2:
                        e.setKeyCode(KeyEvent.VK_NUMPAD8);
                        break;
                    case 3:
                        e.setKeyCode(KeyEvent.VK_NUMPAD2);
                        break;
                    case 4:
                        e.setKeyCode(KeyEvent.VK_NUMPAD4);
                        break;
                    case 5:
                        e.setKeyCode(KeyEvent.VK_NUMPAD6);
                        break;
                }
            }
        }
        if (e.getKeyCode() == KeyEvent.VK_F3) {
            JCPC.system.cpc.GateArray.cpc.saveallowed = !JCPC.system.cpc.GateArray.cpc.saveallowed;
//            System.out.println("Storing DSK is " + (JCPC.system.cpc.GateArray.cpc.saveallowed ? "allowed... " : "not allowed... "));
//            return;
        }
        if (e.getKeyCode() == KeyEvent.VK_F1) {
            JOptionPane.showMessageDialog(new JFrame(), "JavaGX4000 by Markus Hohmann\r\n"
                    + "Contact: webmaster@cpc-live.com\r\n"
                    + "\r\n"
                    + "F1 - This info\r\n"
                    + "F2 - Load medium*\r\n"
                    + "F3 - Enable/disable DSK storing (Off by default)\r\n"
                    //+ "F4 - Store temporary Snapshot\r\n"
                    //+ "F5 - Load temporary Snapshot\r\n"
                    + "F6 - Load cartridge image (CPR)\r\n"
                    + "F7 - Toggle Scanlines (When large)\r\n"
                    + "F8 - Toggle CRTC type (0/1)\r\n"
                    + "F9 - Toggle Turbo\r\n"
                    + "F10 - Setup controller and lightgun / Select internal CPR\r\n"
                    + "F11 - Autotype console\r\n"
                    + "F12 - Reset CPC\r\n"
                    + "\r\n"
                    + "Alt+F12 - Debugger\r\n"
                    + "Alt+Enter - Toggle fullscreen\r\n"
                    + "Print Screen - Poke interface\r\n"
                    + "Scroll Lock - Toggle lightgun\r\n"
                    + "Pause - Amstrad Cartridge Software Demonstrator (CSD) emulation panel\r\n"
                    + "\r\n"
                    + "Joystick is mapped to:\r\n"
                    + "<Insert>/<NP 5> - Fire 0\r\n"
                    + "<Page up>/<NP 0> - Fire 1\r\n"
                    + "<Home>/<NP 8> - Up\r\n"
                    + "<Page down>/<NP 6> - Right\r\n"
                    + "<End>/<NP 2> - Down\r\n"
                    + "<Delete>/<NP 4> - Left\r\n"
                    + "\r\n"
                    + "*Supported media:\r\n"
                    + "DSK, SNA, CDT, CSW, BIN, CPR\r\n");
            return;
        }
        if (e.getKeyCode() == KeyEvent.VK_F7) {
            display.scanlines = !display.scanlines;
            control.filter.setSelected(display.scanlines);
//            return;
        }
        e = translator.translate(e, localkeys);
        if (e.getKeyCode() == KeyEvent.VK_F2) {
            load();
//            return;
        }
        computer.processKeyEvent(e);
        e.consume();
    }
    FileDialog loader;

    protected void load() {
        if (developer) {
            if (loader == null) {
                loader = new FileDialog((Frame) frame,
                        "Load file", FileDialog.LOAD);
            }
//            loader.setFile("*.dsk;*.bin;*.cdt;*.cpr;*.sna;*.csw");
            loader.setVisible(true);
            String filename = loader.getFile();
            if (filename != null) {
                filename = loader.getDirectory() + loader.getFile();
                loadFile(Computer.TYPE_SNAPSHOT, filename, false);
//                System.out.println("File loaded: " + filename);
            }
        }
    }
    boolean lightpen = false;

    public void mouseClicked(MouseEvent e) {
        if (lightpen) {
            return;
        }
        display.requestFocus();
        if (e.getClickCount() == 2 && frame != null && !display.fullscreen && !GateArray.cpc.gx4000) {
            Thread b = new Thread() {
                public void run() {
                    if (menu != null) {
                        menu.jCheckBoxMenuItem2.setSelected(!large);
                        return;
                    }
                    setFullSize(!large);
                    System.out.println("Changing display to " + (large ? "large size" : "small size"));
                    try {
                        Thread.sleep(100);
                    } catch (Exception e) {
                    }
                    display.setPreferredSize(display.getPreferredSize());
                    display.setSize(display.getPreferredSize());
                    try {
                        Thread.sleep(100);
                    } catch (Exception e) {
                    }
                    if (frame != null) {
                        frame.pack();
                        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
                        frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
                    }
                    if (emu != null) {
                        emu.pack();
                    }
                }
            };
            b.start();
        }
    }

    public void mousePressed(MouseEvent e) {
        if (lightpen && !display.menumode) {
            if (e.getButton() != 1) {
                penonscreen = !penonscreen;
                display.penonscreen = penonscreen;
                display.setCursor(penonscreen ? pen : gun);
                return;
            }
            int x = e.getX();
            int y = e.getY();
            if (display.fullscreen) {
                double xx = (double) (768) / (double) display.getWidth();
                double yy = (double) (544) / (double) display.getHeight();
                x = (int) ((double) x * xx);
                y = (int) ((double) y * yy);
            }
            GateArray.cpc.getCRTC().setLightpen(x, y, display.large, display.fullscreen, true);
            computer.keyPressed(penonscreen ? KeyEvent.VK_ENTER : (GateArray.cpc.gx4000 ? KeyEvent.VK_CONTROL : KeyEvent.VK_INSERT));
        }
    }
    final URL cursorim = getClass().getResource("attachment.gif");
    final Image lightGun = getToolkit().getImage(cursorim);
    final URL cursorim2 = getClass().getResource("lightpen.png");
    final Image lightPen = getToolkit().getImage(cursorim2);
    Cursor gun = Toolkit.getDefaultToolkit().createCustomCursor(lightGun, new Point(1, 1), "gunCursor");
    Cursor pen = Toolkit.getDefaultToolkit().createCustomCursor(lightPen, new Point(1, 1), "penCursor");
    int basex = 200;
    int basexmax = 410;

    public void setLightgun(boolean enable) {
        lightpen = enable;
        GateArray.cpc.getCRTC().lightgun = lightpen;
        if (lightpen) {
            display.setCursor(penonscreen ? pen : gun);
        } else {
            display.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        }

    }

    public void mouseReleased(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();
        if (y < 50) {
            display.showtime = 50;
        }
        if (Display.showtime > 0) {
            int d = display.divider;
            if (d == 2) {
                d = 1;
            } else {
                d = 2;
            }
            if (x > 46 / d && x < 76 / d) {
                if (y > 6 / d && y < 38 / d) {
                    System.out.println("Loading disk 1");
                    loadFile(Computer.TYPE_DISC_IMAGE, disk1, true);
                    Samples.INSERT.play();

                }
            }
            if (x > 80 / d && x < 106 / d) {
                if (y > 6 / d && y < 38 / d) {
                    System.out.println("Loading disk 2");
                    loadFile(Computer.TYPE_DISC_IMAGE, disk2, true);
                    Samples.INSERT.play();

                }
            }
        }
        if (menupossible) {
            display.menumode = !display.menumode;
        }
        if (!display.menumode && lightpen) {
            computer.keyReleased(penonscreen ? KeyEvent.VK_ENTER : (GateArray.cpc.gx4000 ? KeyEvent.VK_CONTROL : KeyEvent.VK_INSERT));
            GateArray.cpc.getCRTC().releaseGun();
            return;
        }
        if (display.menumode && display.large) {
//            System.out.println(x + "," + y);
            y -= large ? 50 : 100;

            if (x > basex && x < basexmax) {
                if (y < 480 && y > 0) {
                    int index = y / 32;
//                    System.out.println(index);
                    if (index < 0 || index > display.carts.length - 1) {
                        return;
                    }
                    int hasIndex = controller.cart.getSelectedIndex();
                    controller.cart.setSelectedIndex(index);
                    if (hasIndex == index) {
                        GateArray.cpc.loadCart(index);
                    }
                    display.menumode = false;
                }
            }

            if (x > basex + 300 && x < basexmax + 300) {
                if (y < 320 && y > 0) {
                    int index = 15 + y / 32;
//                    System.out.println(index);
                    if (index < 0 || index > display.carts.length - 1) {
                        return;
                    }
                    int hasIndex = controller.cart.getSelectedIndex();
                    controller.cart.setSelectedIndex(index);
                    if (hasIndex == index) {
                        GateArray.cpc.loadCart(index);
                    }
                    display.menumode = false;
                }
            }
        }
        if (display.menumode && !display.large) {
            y -= 50 + display.ydist;
            x -= display.xdist;

            if (x > 100 && x < 220) {
                if (y < 240 && y > 0) {
                    int index = y / 16;
//                    System.out.println(index);
                    if (index < 0 || index > display.carts.length - 1) {
                        return;
                    }
                    int hasIndex = controller.cart.getSelectedIndex();
                    controller.cart.setSelectedIndex(index);
                    if (hasIndex == index) {
                        GateArray.cpc.loadCart(index);
                    }
                    display.menumode = false;
                }
            }

            if (x > 250 && x < 370) {
                if (y < 210 && y > 0) {
                    int index = 15 + y / 16;
                    if (index < 0 || index > display.carts.length - 1) {
                        return;
                    }
                    int hasIndex = controller.cart.getSelectedIndex();
                    controller.cart.setSelectedIndex(index);
                    if (hasIndex == index) {
                        GateArray.cpc.loadCart(index);
                    }
                    display.menumode = false;
                }
            }
        }
        if (display.mCurrFPS < 24) {
            computer.reSync();
        }
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void loadFile(String name) {
        loadFile(Computer.TYPE_UNKNOWN, name, true);
    }

    public void loadFile(int type, String name, boolean usePath) {

        if (URL) {
            usePath = false;
        }
        try {
            computer.stop();
            computer.loadFile(type, (usePath ? computer.getFilePath() : "") + name);
        } catch (Exception e) {
        }
        computer.start();
        display.requestFocus();
//        computer.start();
    }

    public void resetComputer() {
        JCPC.system.cpc.GateArray.cpc.cprslot = 0;
        computer.reset();
    }

    public void loadGame(int slot) {
        GateArray.cpc.loadCart(slot);
    }

    public void setComputer(final String name) {

        try {
            setComputer(name, true);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(0);
        }
    }

    public void setComputer(String name, boolean start) throws Exception {
        if (computer == null || !name.equalsIgnoreCase(computer.getName())) {
            computer = Computer.createComputer(this, name);
            setFullSize(large);
            computer.initialise();
            if (start) {
                computer.start();
            }
        }
    }
    boolean keepmonitor;
    
    void showHideButtons(boolean show){
        control.controller.setVisible(large);
        control.filter.setVisible(large);
        control.fullscreen.setVisible(large);
    }
    public void setFullSize(boolean value) {
//        display.menumode = false;
//        display.menupos = -600;
        large = value;
        showHideButtons(large);
//        if (!asApplet) {

//        }
        Display.drawmonitor = value ? false : keepmonitor;
        computer.stop();
        display.divider = large ? 2 : 1;
        display.large = large;
        computer.setLarge(large);
        display.setImageSize(computer.getDisplaySize(large), computer.getDisplayScale(large));
        computer.setDisplay(display);
        computer.start();
        show.repaint();
        display.requestFocus();
    }

    public void focusLost(FocusEvent e) {
        computer.displayLostFocus();
        if (display.mCurrFPS < 45) {
            computer.reSync();
        }
    }

    public void focusGained(FocusEvent e) {
        if (display.mCurrFPS < 45) {
            computer.reSync();
        }
    }
    static JFrame frame;

    public void initMenu() {
        menu = new GX4000Menu();
        menu.setVisible(true);
        menu.jMenuItem1.addActionListener(this);
        menu.jMenuItem2.addActionListener(this);
        menu.jMenuItem3.addActionListener(this);
        menu.jMenuItem5.addActionListener(this);
        menu.jMenuItem7.addActionListener(this);
        menu.jMenuItem8.addActionListener(this);
        menu.jCheckBoxMenuItem1.addItemListener(this);
        menu.jCheckBoxMenuItem2.addItemListener(this);
        menu.jCheckBoxMenuItem3.addItemListener(this);
        menu.jCheckBoxMenuItem4.addItemListener(this);
        menu.jCheckBoxMenuItem7.addItemListener(this);
    }

    public static void setStyle() {

        try {
            NimRODTheme nt = new NimRODTheme();
            Color flow1 = new Color(0x4B0005);
            Color flow3 = new Color(0xEAF1F2);
//            Color black = new Color(0x494854);
            Color black = new Color(0x000000);
            Color white = new Color(0xFFFFFF);
            Color sec1 = new Color(0xA40020); // button borders
            Color sec2 = new Color(0x93373D); // panel borders
            Color sec3 = new Color(0xF6F4EA);
            Color select = new Color(0xA40020);

            nt.setPrimary(white);
            nt.setSecondary(white);
            nt.setPrimary1(flow1); // left corner
            nt.setPrimary3(flow3); // right corner

            nt.setPrimary2(select); // selected/marked items

            nt.setSecondary1(sec1);
            nt.setSecondary2(sec2);
            nt.setSecondary3(sec3);
            nt.setBlack(black); // dialogfield text
            nt.setWhite(white); // textfield background
            nt.setMenuOpacity(195);
            nt.setFrameOpacity(120);

            NimRODLookAndFeel NimRODLF = new NimRODLookAndFeel();
            NimRODLF.setCurrentTheme(nt);
            UIManager.setLookAndFeel(NimRODLF);
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                System.out.println(info.getName());
//                if (info.getName().toLowerCase().contains("windows")) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
        } catch (Exception ex) {
        }
    }

    public static boolean asApplet = true;

    public static void main(String[] args) {
        asApplet = false;
        setStyle();
        CPC.gx4000 = true;
        developer = true;
        GX4000 applet = new GX4000();
        applet.isStandalone = true;
        frame = new JFrame() {
            protected void processWindowEvent(WindowEvent e) {
                super.processWindowEvent(e);
                if (e.getID() == WindowEvent.WINDOW_CLOSING) {
                    System.exit(0);
                }
            }

            public synchronized void setTitle(String title) {
                super.setTitle(title);
                enableEvents(AWTEvent.WINDOW_EVENT_MASK);
            }
        };
        frame.setTitle("JavaGX4000");
        frame.getContentPane().add(applet, BorderLayout.CENTER);
        applet.initMenu();
        //frame.setBackground(Color.black);
        applet.init();
        applet.start();
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
                frame.setLocation((d.width - 800) / 2, (d.height - 600) / 2);
                frame.setVisible(true);
                frame.setResizable(false);
                frame.pack();
            }
        });
    }
}
